CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


PUB grab(sample) | id, status 
    Status~                                          'clear status register
     _Status := @Status   
    id := cognew(@asm_entry2, sample)   'launch assembly program in a COG
   
    repeat while Status == 0 


DAT

              org 0

asm_entry2                  
              mov       t1,par
              rdlong    delay,t1
              add       t1,#4
              rdlong    asm_sample,t1
              add       t1,#4
              mov       buf_out,t1
              mov       buf_cnt,#192

              mov       asm_cc,cnt
              add       asm_cc,delay
               
loop          waitcnt   asm_cc,delay
              rdlong    asm_temp,asm_sample
              wrlong    asm_temp,buf_out
              add       buf_out,#4   
              djnz      buf_cnt,#loop
              
              mov       t1, #1                  'Update 'Status' register indicating that data is ready
              wrlong    t1, _Status
              cogid     t1
              cogstop   t1 
              

_Status       LONG      0 


asm_c         res       1        'uninitialized variables follow emitted data
asm_cc        res       1
asm_cnt       res       1
asm_new       res       1
asm_old       res       1
asm_sample    res       1
asm_temp      res       1
asm_temp2     res       1
delay         res       1
t1            res       1                        
buf_base      res       1
buf_ptr       res       1
buf_cnt       res       1
buf_out       res       1
