CON
'
' Configuration file for  AM Radio
'
  _clkmode = xtal1 + pll16x
'  _xinfreq = 5_000_000
  _clkfreq = 80_000_000

  rf_pin        = 19            'Input pin for RF from antenna or RF amplifier.
  fb_pin        = 20            'Feedback pin for delta-sigma ADC.
  if_pin        = 7             'I quadrature output pin.
  qf_pin        = 6             'Q quadrature output pin.
  au_pin        = 11            'Audio output pin.

  fsample       = 10000 '16000         'Audio sample rate in Hz.
  clks          = 80_000_000 / fsample 'Processor clocks per sample (assumes 80MHz clock).
  mclks         = clks / 2      'Clocks for half a sample ("zero" level for ADC).

  SDBase   = 0                  ' basepin 1 of 4 for SD memory

  basepin  = 12
' basepin  = 12                'Setting for Demo Board TV.
' basepin  = 24                'Setting for Hydra TV.
' basepin  = 16                'Setting for Demo Board & Hydra VGA

'  kbd = 11 ' keyboard data pin dongle
'  kbc = 10 ' keyboard clock pin dongle
  kbd = 26 ' keyboard data pin proto/demo board
  kbc = 27 ' keyboard clock pin proto/demo board

PUB config

